/* fxsp2lib.c */

#include <stdlib.h>
#include <stdio.h>

#define	SPRITE_MAX	32
#define	FRAME_MAX	256

typedef struct {
	signed short vx;	/* ΍Wf[^ */
	signed short vy;	/* ΍Wf[^ */
	unsigned short pt;	/* XvCgp^[mD */
	unsigned short rv;	/* ]R[h */
} SP_WORK;

static int frame_no = 0;
static int sprite_no = 0;
static int sprite_no_max[FRAME_MAX];
static char *fname = "temp001.obj";

SP_WORK sp_work[FRAME_MAX][SPRITE_MAX];


short fxsp_on (void)
{
	return (0);
}



/* xsp_set_st ƒuĎgƈ̍\̂ .obj t@Cɏo */
short fxsp_set_st (void *sp_work0)
{
	if (sprite_no < SPRITE_MAX) {
		sp_work[frame_no][sprite_no].vx = ((SP_WORK *) sp_work0)->vx;
		sp_work[frame_no][sprite_no].vy = ((SP_WORK *) sp_work0)->vy;
		sp_work[frame_no][sprite_no].pt = ((SP_WORK *) sp_work0)->pt;
		sp_work[frame_no][sprite_no].rv = ((SP_WORK *) sp_work0)->rv;

		sprite_no++;
	}
	return (0);
}



short fxsp_out (void)
{
	short s = sprite_no;

	sprite_no_max[frame_no++] = sprite_no;
	sprite_no = 0;

	return (s);
}



static void write_pos (FILE * fp, signed short pos)
{
	signed short p = pos - 144;

	if (p < 0)
		fprintf (fp, "-$%04hx	", -p);
	else
		fprintf (fp, " $%04hx	", p);

	return;
}



short fxsp_off (void)
{
	FILE *fp;
	int i, j;

	if ((fp = fopen (fname, "w")) == NULL) {
		printf ("t@C߂܂\n");
		return (-1);
	}
	fprintf (fp, "\nPCG_FILE	=	*.sp	256	* gp PCG f[^\n"
		 "\n"
		 "XY_OFFSET	=	$0000	$0000	* W̃ItZbg\n"
		 "PT_OFFSET	=	$0000		* obfp^[io[̃ItZbg\n"
		 "OBJ_RV		=	$0000		* Ŝ̔]R[h\n"
		 "\n"
		 "No.		=	*	* XvCg̃p^[io[\n"
		 "\n");


	for (i = 0; i < frame_no; i++) {
		fprintf (fp,
			 "******************************** XvCgp^[ %3d ****\n\n"
			 "No.	=	NEXT	* XvCg̃p^[io[\n"
			 "			* 珇ɁAX Y PT RV iȉlj\n"
			 ,i, i);

		for (j = 0; j < sprite_no_max[i]; j++) {
			fprintf (fp, "	");
			write_pos (fp, sp_work[i][j].vx);
			write_pos (fp, sp_work[i][j].vy);

			fprintf (fp, "$%04x	", sp_work[i][j].pt);
			fprintf (fp, "$%04x\n", sp_work[i][j].rv);
		}

		fprintf (fp, "\n\n");
	}
	fclose (fp);

	return (0);

}
